<?php function ft_bufferapp_config() {
	$key = get_option('ft_bufferapp_consumer_key');
	$secret = get_option('ft_bufferapp_consumer_secret');
	$token = get_option('ft_bufferapp_token');
	$profiles = get_option('ft_bufferapp_profiles');
	
	if (isset($_POST['submit'])) {
		if (function_exists('current_user_can') && !current_user_can('manage_options')) {
			die(__('Cheatin&#8217; uh?'));
		}
		
		check_admin_referer('ft-bufferapp-config');
		
		$key = $_POST['ft_bufferapp_consumer_key'];
		$secret = $_POST['ft_bufferapp_consumer_secret'];
		
		if($key && $secret) {
			update_option('ft_bufferapp_consumer_key', $key);
			update_option('ft_bufferapp_consumer_secret', $secret);
		}
	} elseif (isset($_POST['clear'])) {
		delete_option('ft_bufferapp_consumer_key');
		delete_option('ft_bufferapp_consumer_secret');
		delete_option('ft_bufferapp_token');
		delete_option('ft_bufferapp_profiles');
		
		$key = null;
		$secret = null;
		$token = null;
		$profiles = none;
	} elseif(isset($_POST['sync'])) {
		if($key && $secret && $token) {
			ft_bufferapp_syncprofiles();
		}
	} elseif($key && $secret && $token && !$profiles) {
		ft_bufferapp_syncprofiles();
	}
	
	?>
	<div class="wrap">
		<div id="icon-options-general" class="icon32"><br></div>
		<h2><?php printf(__('%s settings', 'ft-bufferapp'), 'Buffer'); ?></h2>
		
		<?php if(!$key || !$secret || !$token) { ?>
			<div class="narrow">
				<h3><?php print(__('First, create an app that your blog can use', 'ft-bufferapp')); ?></h3>
				<ol>
					<li><?php printf(
						__('Start by <a href="%s" target="_blank"><strong>creating an app</strong></a> on %s', 'ft-bufferapp'),
						'http://bufferapp.com/developers/apps/create', 'bufferapp.com'
					); ?>
						<ul>
							<li><?php printf(
								__('<strong>Important:</strong> Set the callback URL to <code>%s</code>', 'ft-bufferapp'),
								plugins_url('post-to-buffer/callback.php')
							); ?></li>
						</ul>
					</li>
					<li>
						<?php printf(
							__('Wait for an email from %s, which contains your <strong>client ID</strong> and <strong>secret</strong>.', 'ft-bufferapp'),
							'Buffer'
						); ?>
					</li>
					<li><?php print(
						__('Put the Client ID and Token in the boxes below', 'ft-bufferapp')
					); ?></li>
				</ol>
				
				<form method="post">
					<div>
						<h3><?php print(__('App details', 'ft-bufferapp')); ?></h3>
						<table>
							<tbody>
								<tr>
									<td><label for="ft_bufferapp_consumer_key">Client ID</label></td>
									<td><input id="ft_bufferapp_consumer_key" name="ft_bufferapp_consumer_key" type="text" value="<?php echo $key; ?>"<?php if($key) echo ' readonly'; ?>/></td>
								</tr>
								
								<tr>
									<td><label for="ft_bufferapp_consumer_url">Redirect URL</label></td>
									<td><input id="ft_bufferapp_consumer_url" type="text" readonly value="<?php echo plugins_url('post-to-buffer/callback.php'); ?>" /></td>
								</tr>
								
								<tr>
									<td><label for="ft_bufferapp_consumer_secret">Client secret</label></td>
									<td><input id="ft_bufferapp_consumer_secret" name="ft_bufferapp_consumer_secret" type="text" value="<?php echo $secret; ?>"<?php if($key) echo ' readonly'; ?> /><br /></td>
								</tr>
								
								<tr>
									<td></td>
									<td>
										<?php printf(__('This is not the same as Your Token. You need to wait for the email from %s', 'ft-bufferapp'), 'Buffer'); ?>
									</td>
								</tr>
							</tbody>
						</table>
						
						<?php akismet_nonce_field('ft-bufferapp-config'); ?>
						<p class="submit">
							<input type="submit" name="submit" value="<?php _e('Update options &raquo;'); ?>"<?php if($key) echo ' disabled'; ?> />
							<?php if($key && $secret) { ?>
							<input type="submit" name="clear" value="<?php _e('Start again'); ?>" />
							<?php } ?>
						</p>
					</div>
				</form>
			</div>
		<?php } ?>
		
		<?php if($key && $secret && !$token) { ?>
			<h3><?php printf(__('Now, login to %s', 'ft-bufferapp'), 'Buffer'); ?></h3>
			<p><?php printf(__('Now you\'ve created your app, you need to login to %s so we can connect your accounts up.', 'ft-bufferapp'), 'Buffer'); ?></p>
			<p>
				<a class="button" href="<?php echo "https://bufferapp.com/oauth2/authorize?client_id=${key}&redirect_uri=${url}&response_type=code"; ?>"><?php printf(__('Login to %s', 'ft-bufferap'), 'Buffer'); ?></a>
			</p>
		<?php } ?>
		
		<?php if($key && $secret && $token) { ?>
			<h3><?php printf(__('Profiles', 'ft-bufferapp')); ?></h3>
			<p>
				<?php printf(__('We\'ve found the following profiles in your %s account.<br />When you create a post, you\'ll be able to choose which services to post to.', 'ft-bufferapp'), 'Buffer'); ?>
			</p>
			
			<form method="post">
				<ul>
					<?php foreach($profiles as $profile) { ?>
						<li><?php echo $profile['verbose_name']; ?></li>
					<?php } ?>
				</ul>
				
				<p>
					<?php printf(
						__('If you\'ve made any changes, you can synchronise this blog with your %s account again.', 'ft-bufferapp'),
						'Buffer'
					); ?>
				</p>
				
				<p class="submit">
					<input type="submit" name="sync" value="<?php _e('Sync my profiles &raquo;'); ?>" />
					<input type="submit" name="clear" value="<?php _e('Clear my details'); ?>" />
				</p>
			</form>
		<?php } ?>
	</div>
<?php } ?>